#ifndef _SQLCLASS_H
#define _SQLCLASS_H
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <SQL.H>
#include <SqlExt.H>

#include "CSQL.H"
#include "CRecordSet.H"

#define MAXSQLBUFLEN  255
#define MAXSQLCONNOUT 1024

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CSQL{
    public:
		bool Connect(char *, char *, char *, char *, char *);
        void CloseCursor(HSTMT);
        bool Execute(char *, CRecordSet *MyRS);
		bool ExecuteNonQuery(char *Statement);
        void Disconnect(void);
        bool GetErrorMessage(char *, HSTMT);
        bool Fetch(HSTMT);
        bool GetData(HSTMT, SQLUSMALLINT, SQLSMALLINT, SQLPOINTER, SQLINTEGER, SQLINTEGER *);
		bool ThrowError(HSTMT hStmt);
		bool ThrowErrorIfSet(HSTMT hStmt);

        CSQL();
        ~CSQL();

		bool bThrowErrors;

    private:
        HENV SQLEnvironment;
        HDBC SQLConnection;
        bool Connected;
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
